import TemplateParseError from "./errors/template-parse-error.js";
export function buildStackTrace(stackTrace) {
    return stackTrace.map((entry, i) => entry.map(value => "   ".repeat(i) + value).join("\n")).join("\n");
}
export function scapeBrackets(value) {
    return value.replace(/(?<!\\)\\{/g, "{").replace(/\\\\{/g, "\\");
}
export function throwTemplateParseError(message, stackTrace) {
    throw new TemplateParseError(message, buildStackTrace(stackTrace));
}
