import type { ArrayPattern, ArrowFunctionExpression, AssignmentExpression, AssignmentPattern, AssignmentProperty, CallExpression, ConditionalExpression, INode, Identifier, LogicalExpression, MemberExpression, NewExpression, ParenthesizedExpression, Property, RestElement, TaggedTemplateExpression, ThisExpression, UpdateExpression } from "@surface/expression";
import { ExpressionVisitor } from "@surface/expression";
export default class ObserverVisitor extends ExpressionVisitor {
    private readonly paths;
    private brokenPath;
    private stack;
    static observe(expression: INode): [string, ...string[]][];
    private commit;
    private reset;
    private rollback;
    protected visitArrayPattern(expression: ArrayPattern): INode;
    protected visitArrowFunctionExpression(expression: ArrowFunctionExpression): INode;
    protected visitAssignmentExpression(expression: AssignmentExpression): INode;
    protected visitAssignmentPattern(expression: AssignmentPattern): INode;
    protected visitAssignmentProperty(expression: AssignmentProperty): INode;
    protected visitCallExpression(expression: CallExpression): INode;
    protected visitLogicalExpression(expression: LogicalExpression): INode;
    protected visitConditionalExpression(expression: ConditionalExpression): INode;
    protected visitIdentifier(expression: Identifier): INode;
    protected visitMemberExpression(expression: MemberExpression): INode;
    protected visitNewExpression(expression: NewExpression): INode;
    protected visitParenthesizedExpression(expression: ParenthesizedExpression): INode;
    protected visitProperty(expression: Property): INode;
    protected visitRestElement(expression: RestElement): INode;
    protected visitTaggedTemplateExpression(expression: TaggedTemplateExpression): INode;
    protected visitThisExpression(expression: ThisExpression): INode;
    protected visitUpdateExpression(expression: UpdateExpression): INode;
}
