import type Descriptor from "./types/descriptor.js";
import type StackTrace from "./types/stack-trace.js";
export default class Parser {
    private readonly document;
    private readonly name;
    private readonly stackTrace;
    private index;
    constructor(document: Document, name: string, stackTrace?: StackTrace);
    static parse(document: Document, name: string, template: string): Descriptor;
    private attributeToString;
    private decomposeDirectives;
    private elementToTemplate;
    private enumerateDirectives;
    private enumerateParsedNodes;
    private isDecomposed;
    private hasTemplateDirectives;
    private markAsDecomposed;
    private nodeToString;
    private parse;
    private parseAttributes;
    private parseDirectives;
    private parseElement;
    private parseTemplate;
    private parseTextNode;
    private pushToStack;
    private removeDirectives;
    private trimContent;
    private tryParseExpression;
    private validateMemberExpression;
}
